// Window class header
#pragma once

#include "nf/config.h"

#include <Windows.h>

namespace nf::cli {
    class Window {
    public:
        Window(const char* windowTitle);

        HWND getHandle() const;
        void setDisplay(DisplayConfig config);
        void runLoop();
        void show(bool show = true);
    private:
        void registerWindowClass();
        static LRESULT CALLBACK wndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
        SIZE getWindowSize();

        HWND m_handle;

        const char* m_wndClassName;
        const DWORD m_windowedStyle;
        const DWORD m_fullscreenStyle;

        unsigned int m_width, m_height;
    };
}
