// RenderEngine class header
#pragma once

#include "client/Window.h"
#include "nf/config.h"

namespace nf::cli::render {
    class RenderEngine {
    public:
        RenderEngine(std::shared_ptr<Window> window, DisplayConfig display);

        ~RenderEngine();
    private:
        void createInstance();
        void createSurface(HWND window);
        void pickPhysicalDevice();

        std::shared_ptr<Window> m_window;
        DisplayConfig m_display;

        VkInstance m_instance;
        VkSurfaceKHR m_surface;
        VkPhysicalDevice m_physicalDevice;
        uint32_t m_queueFIGraphics, m_queueFIPresent;
    };
}
